import { Mode } from 'codemirror';
declare module 'codemirror' {
    function copyState<T = any>(mode: any, state: T): T;
}
export declare type PatternLike = RegExp | string | ((text: string, from: number, state: ITemplateState) => [number, string | null]);
export interface IPattern {
    mode: any;
    open?: PatternLike;
    close?: PatternLike;
    escape?: PatternLike;
    children?: IPattern[];
    includePattern?: boolean;
    patternStyles?: [string | null, string | null];
}
export declare type Callback = (state: ITemplateState, info: {
    line: string;
    pos: number;
    textBefore: string;
    matched: string | null;
    pattern: IPattern | null;
}) => void;
export interface ITemplateOptions extends IPattern {
    name: 'cxj-template';
    codeMode: any;
    beforeEnter?: Callback;
    afterEnter?: Callback;
    beforeExit?: Callback;
    afterExit?: Callback;
}
export interface IPatternContext {
    pre: IPatternContext | null;
    pattern: IPattern;
}
export interface IStateContext {
    pre: IStateContext | null;
    mode: Mode<any>;
    state: any;
}
export interface ITemplateState {
    textBefore: string;
    patternContext: IPatternContext;
    stateContext: IStateContext | null;
    useRoot: boolean;
    start: boolean;
    layers?: ILayer[];
    regExpCache: {
        [source: string]: RegExp;
    };
    customs: {
        [key: string]: any;
    };
}
interface ILayer {
    pos: number;
    matched: string | null;
    open: boolean;
    prePattern: IPattern;
    nextPattern: IPattern;
}
export declare function createDefaultOptions(baseMode: any, codeMode: any): ITemplateOptions;
export {};
